function AaoTabletLink() {
	var AAO_URL_PART = "http://localhost:";
	var lastString = '';
	var dloop;
	var allBtns = [];

	function DataLoop () {
		let forceUpdate = SimVar.GetSimVarValue('L:AAO_FMC_HTML_INIT', 'Number');
		let apiport = SimVar.GetSimVarValue('L:AaoWebApiPort', 'Number');
		if (apiport != 0) {
			let bIdx = 0;
			let currStr = "";
			let requestObj = {};
			requestObj.setstringvars = [];
			requestObj.scripts = [];
			let lastlen = allBtns.length;
			allBtns = [];
			let toppage = null;
			let navstrip = document.getElementsByTagName("nav");
			if (navstrip && navstrip.length > 0){
				toppage = navstrip[0].parentElement;
			}
			if (toppage){
				let btns = toppage.children[0].getElementsByTagName("a");
				if (btns){
					let currStr = "";
					for (let bi = 0; bi < btns.length; bi++){
						if (btns[bi]){
							let toset = { "var": "(L:FBW_TABLET_BUTTON_" + make2digits((bIdx++).toString()) + ", String)", "value": btns[bi].href };
							requestObj.setstringvars.push(toset);
							allBtns.push(btns[bi]);
							currStr += btns[bi].href;
						}
					}
				}
			}
			if (toppage){
				let contents = toppage.children[1];
				if (contents){
					let btns = contents.getElementsByTagName("a");
					if (btns){
						let currStr = "";
						for (let bi = 0; bi < btns.length; bi++){
							if (btns[bi]){
								let toset = { "var": "(L:FBW_TABLET_BUTTON_" + (bIdx++).toString() + ", String)", "value": btns[bi].href };
								requestObj.setstringvars.push(toset);
								allBtns.push(btns[bi]);
								currStr += btns[bi].href;
							}
						}
					}
					btns = contents.getElementsByTagName("button");
					if (btns){
						for (let bi = 0; bi < btns.length; bi++){
							if (btns[bi]){
								let hdr = btns[bi].innerText;
								if (hdr.length == 0)
									hdr = btns[bi].parentElement.innerText;
								let toset = { "var": "(L:FBW_TABLET_BUTTON_" + (bIdx++).toString() + ", String)", "value": hdr.replace(/(\r\n|\n|\r)/gm, "") };
								requestObj.setstringvars.push(toset);
								allBtns.push(btns[bi]);
								currStr += hdr;
							}
						}
					}
					btns = contents.getElementsByClassName("items-center");
					if (btns){
						for (let bi = 0; bi < btns.length; bi++){
							if (btns[bi]){
								let hdr = btns[bi].innerText;
								if (hdr.length == 0)
									hdr = btns[bi].parentElement.innerText;
								let toset = { "var": "(L:FBW_TABLET_BUTTON_" + (bIdx++).toString() + ", String)", "value": hdr.replace(/(\r\n|\n|\r)/gm, "")};
								requestObj.setstringvars.push(toset);
								allBtns.push(btns[bi]);
								currStr += hdr;
							}
						}
					}
					btns = contents.getElementsByTagName("input");
					if (btns){
						for (let bi = 0; bi < btns.length; bi++){
							if (btns[bi]){
								if (btns[bi].type === 'checkbox' || btns[bi].type === 'radio'){
									let hdr = btns[bi].innerText;
									if (hdr.length == 0)
										hdr = btns[bi].parentElement.innerText;
									let toset = { "var": "(L:FBW_TABLET_BUTTON_" + (bIdx++).toString() + ", String)", "value": hdr.replace(/(\r\n|\n|\r)/gm, "")};
									requestObj.setstringvars.push(toset);
									allBtns.push(btns[bi]);
									currStr += hdr;
								}
							}
						}
					}
					btns = contents.getElementsByClassName("cursor-pointer");
					if (btns){
						for (let bi = 0; bi < btns.length; bi++){
							if (btns[bi]){
								let hdr = btns[bi].innerText;
								if (hdr.length == 0)
									hdr = btns[bi].parentElement.innerText;
								let toset = { "var": "(L:FBW_TABLET_BUTTON_" + (bIdx++).toString() + ", String)", "value": hdr.replace(/(\r\n|\n|\r)/gm, "")};
								requestObj.setstringvars.push(toset);
								allBtns.push(btns[bi]);
								currStr += hdr;
							}
						}
					}
				}
			}
			for (let i = allBtns.length; i < lastlen; i++){
				let toset = { "var": "(L:FBW_TABLET_BUTTON_" + (bIdx++).toString() + ", String)", "value": "" };
				requestObj.setstringvars.push(toset);
			}
				
			if (currStr !== lastString){
				lastString = currStr;
				let toset = { "code": "(EXPORTVARS:FBW_TABLET,fbwtabletitems)" };
				requestObj.scripts.push(toset);
				let relxhttp = new XMLHttpRequest();
				let relurl = encodeURI(AAO_URL_PART + apiport.toString() + "/webapi/");
				relxhttp.open("POST", relurl);
				relxhttp.send(JSON.stringify(requestObj));
			}
			var getrequestObj = {};
			getrequestObj.pullstringlvars = [];
			let tosend = { "var": "(L:FBW_TABLET_BUTTON_PUSHED, String)", "value": ""};
			getrequestObj.pullstringlvars.push(tosend);
			var grelxhttp = new XMLHttpRequest();
			grelxhttp.addEventListener("load", aaoDataRequestListener);
			let relurl = encodeURI(AAO_URL_PART + apiport.toString() + "/webapi/");
			grelxhttp.open("POST", relurl);
			grelxhttp.send(JSON.stringify(getrequestObj));
		}
	};
	
	function make2digits(num){
		if (num < 10)
			return '0' + num;
		return num;
	}
	
	function aaoDataRequestListener (){
		let commObj = JSON.parse(this.responseText);
		let buttonArr = commObj.pullstringlvars[0].value;
		let btns = buttonArr.split(',');
		for (let bi = 0; bi < btns.length; bi++){
			let idx = parseInt(btns[bi]);
			if (idx < allBtns.length){
				let btn = allBtns[idx];
				if (btn)
					btn.click();
			}
		}
	};
	
	this.startup = function () {
		dloop = setInterval(DataLoop, 100);
	};
	
	this.shutdown = function () {
		clearInterval(dloop);
	};
};

var aaotabletmodule = new AaoTabletLink();
aaotabletmodule.startup();
